/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export type SellNftTokenPoolT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountSeller extends string | IAccountMeta<string> = string, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountSellerTa extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSharedEscrow extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountAmmProgram extends string | IAccountMeta<string> = 'TAMM6ub33ij1mbetoMyVBLeKY5iP41i4UPUJQGkhfsg', TAccountEscrowProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountSeller extends string ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller,
    TAccountRentPayer extends string ? WritableAccount<TAccountRentPayer> : TAccountRentPayer,
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountSellerTa extends string ? WritableAccount<TAccountSellerTa> : TAccountSellerTa,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSharedEscrow extends string ? WritableAccount<TAccountSharedEscrow> : TAccountSharedEscrow,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountAmmProgram extends string ? ReadonlyAccount<TAccountAmmProgram> : TAccountAmmProgram,
    TAccountEscrowProgram extends string ? ReadonlyAccount<TAccountEscrowProgram> : TAccountEscrowProgram,
    ...TRemainingAccounts
]>;
export type SellNftTokenPoolT22InstructionData = {
    discriminator: ReadonlyUint8Array;
    minPrice: bigint;
};
export type SellNftTokenPoolT22InstructionDataArgs = {
    minPrice: number | bigint;
};
export declare function getSellNftTokenPoolT22InstructionDataEncoder(): Encoder<SellNftTokenPoolT22InstructionDataArgs>;
export declare function getSellNftTokenPoolT22InstructionDataDecoder(): Decoder<SellNftTokenPoolT22InstructionData>;
export declare function getSellNftTokenPoolT22InstructionDataCodec(): Codec<SellNftTokenPoolT22InstructionDataArgs, SellNftTokenPoolT22InstructionData>;
export type SellNftTokenPoolT22AsyncInput<TAccountOwner extends string = string, TAccountSeller extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSellerTa extends string = string, TAccountOwnerTa extends string = string, TAccountMint extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string> = {
    /** The owner of the pool and the buyer/recipient of the NFT. */
    owner: Address<TAccountOwner>;
    /** The seller is the owner of the NFT who is selling the NFT into the pool. */
    seller: TransactionSigner<TAccountSeller>;
    /** The original rent-payer account that paid for the pool to be opened. Stored on the pool. */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault?: Address<TAccountFeeVault>;
    /**
     * The Pool state account that the NFT is being sold into. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Token type and the NFT passes at least one
     * whitelist condition.
     */
    pool: Address<TAccountPool>;
    /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The token account of the NFT for the seller's wallet. */
    sellerTa?: Address<TAccountSellerTa>;
    /** The ATA of the owner, where the NFT will be transferred to as a result of this sale. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The mint account of the NFT being sold. */
    mint: Address<TAccountMint>;
    /** The Token 2022 program. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The shared escrow account for pools that have liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Missing check is performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    /** The escrow program account for shared liquidity pools. */
    escrowProgram?: Address<TAccountEscrowProgram>;
    minPrice: SellNftTokenPoolT22InstructionDataArgs['minPrice'];
    creators?: Array<Address>;
    transferHookAccounts: Array<Address>;
};
export declare function getSellNftTokenPoolT22InstructionAsync<TAccountOwner extends string, TAccountSeller extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSellerTa extends string, TAccountOwnerTa extends string, TAccountMint extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string>(input: SellNftTokenPoolT22AsyncInput<TAccountOwner, TAccountSeller, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSellerTa, TAccountOwnerTa, TAccountMint, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>): Promise<SellNftTokenPoolT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountSeller, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSellerTa, TAccountOwnerTa, TAccountMint, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>>;
export type SellNftTokenPoolT22Input<TAccountOwner extends string = string, TAccountSeller extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountSellerTa extends string = string, TAccountOwnerTa extends string = string, TAccountMint extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string> = {
    /** The owner of the pool and the buyer/recipient of the NFT. */
    owner: Address<TAccountOwner>;
    /** The seller is the owner of the NFT who is selling the NFT into the pool. */
    seller: TransactionSigner<TAccountSeller>;
    /** The original rent-payer account that paid for the pool to be opened. Stored on the pool. */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault: Address<TAccountFeeVault>;
    /**
     * The Pool state account that the NFT is being sold into. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Token type and the NFT passes at least one
     * whitelist condition.
     */
    pool: Address<TAccountPool>;
    /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The token account of the NFT for the seller's wallet. */
    sellerTa: Address<TAccountSellerTa>;
    /** The ATA of the owner, where the NFT will be transferred to as a result of this sale. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The mint account of the NFT being sold. */
    mint: Address<TAccountMint>;
    /** The Token 2022 program. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The shared escrow account for pools that have liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Missing check is performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    /** The escrow program account for shared liquidity pools. */
    escrowProgram?: Address<TAccountEscrowProgram>;
    minPrice: SellNftTokenPoolT22InstructionDataArgs['minPrice'];
    creators?: Array<Address>;
    transferHookAccounts: Array<Address>;
};
export declare function getSellNftTokenPoolT22Instruction<TAccountOwner extends string, TAccountSeller extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountSellerTa extends string, TAccountOwnerTa extends string, TAccountMint extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string>(input: SellNftTokenPoolT22Input<TAccountOwner, TAccountSeller, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSellerTa, TAccountOwnerTa, TAccountMint, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>): SellNftTokenPoolT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountSeller, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountSellerTa, TAccountOwnerTa, TAccountMint, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>;
export type ParsedSellNftTokenPoolT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the buyer/recipient of the NFT. */
        owner: TAccountMetas[0];
        /** The seller is the owner of the NFT who is selling the NFT into the pool. */
        seller: TAccountMetas[1];
        /** The original rent-payer account that paid for the pool to be opened. Stored on the pool. */
        rentPayer: TAccountMetas[2];
        /** Fee vault account owned by the TFEE program. */
        feeVault: TAccountMetas[3];
        /**
         * The Pool state account that the NFT is being sold into. Stores pool state and config,
         * but is also the owner of any NFTs in the pool, and also escrows any SOL.
         * Any active pool can be specified provided it is a Token type and the NFT passes at least one
         * whitelist condition.
         */
        pool: TAccountMetas[4];
        /** The whitelist account that the pool uses to verify the NFTs being sold into it. */
        whitelist: TAccountMetas[5];
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[6] | undefined;
        /** The token account of the NFT for the seller's wallet. */
        sellerTa: TAccountMetas[7];
        /** The ATA of the owner, where the NFT will be transferred to as a result of this sale. */
        ownerTa: TAccountMetas[8];
        /** The mint account of the NFT being sold. */
        mint: TAccountMetas[9];
        /** The Token 2022 program. */
        tokenProgram: TAccountMetas[10];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[11];
        /** The Solana system program. */
        systemProgram: TAccountMetas[12];
        /** The shared escrow account for pools that have liquidity in a shared account. */
        sharedEscrow?: TAccountMetas[13] | undefined;
        /** The account that receives the maker broker fee. */
        makerBroker?: TAccountMetas[14] | undefined;
        /** The account that receives the taker broker fee. */
        takerBroker?: TAccountMetas[15] | undefined;
        /**
         * The optional cosigner account that must be passed in if the pool has a cosigner.
         * Missing check is performed in the handler.
         */
        cosigner?: TAccountMetas[16] | undefined;
        /** The AMM program account, used for self-cpi logging. */
        ammProgram: TAccountMetas[17];
        /** The escrow program account for shared liquidity pools. */
        escrowProgram?: TAccountMetas[18] | undefined;
    };
    data: SellNftTokenPoolT22InstructionData;
};
export declare function parseSellNftTokenPoolT22Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedSellNftTokenPoolT22Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=sellNftTokenPoolT22.d.ts.map