/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export type SellNftTradePoolT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountSeller extends string | IAccountMeta<string> = string, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountSellerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenzQdBNbLqP5VEhdkAS6EPFLC1PHnBqCXEpPxuEb', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSharedEscrow extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountAmmProgram extends string | IAccountMeta<string> = 'TAMM6ub33ij1mbetoMyVBLeKY5iP41i4UPUJQGkhfsg', TAccountEscrowProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountSeller extends string ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller,
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountSellerTa extends string ? WritableAccount<TAccountSellerTa> : TAccountSellerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSharedEscrow extends string ? WritableAccount<TAccountSharedEscrow> : TAccountSharedEscrow,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountAmmProgram extends string ? ReadonlyAccount<TAccountAmmProgram> : TAccountAmmProgram,
    TAccountEscrowProgram extends string ? ReadonlyAccount<TAccountEscrowProgram> : TAccountEscrowProgram,
    ...TRemainingAccounts
]>;
export type SellNftTradePoolT22InstructionData = {
    discriminator: ReadonlyUint8Array;
    minPrice: bigint;
};
export type SellNftTradePoolT22InstructionDataArgs = {
    minPrice: number | bigint;
};
export declare function getSellNftTradePoolT22InstructionDataEncoder(): Encoder<SellNftTradePoolT22InstructionDataArgs>;
export declare function getSellNftTradePoolT22InstructionDataDecoder(): Decoder<SellNftTradePoolT22InstructionData>;
export declare function getSellNftTradePoolT22InstructionDataCodec(): Codec<SellNftTradePoolT22InstructionDataArgs, SellNftTradePoolT22InstructionData>;
export type SellNftTradePoolT22AsyncInput<TAccountOwner extends string = string, TAccountSeller extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountSellerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string> = {
    /** The owner of the pool and the buyer of the NFT, though the NFT will be escrowed by the pool. */
    owner: Address<TAccountOwner>;
    /** The seller is the owner of the NFT who is selling the NFT into the pool. */
    seller: TransactionSigner<TAccountSeller>;
    /** Fee vault account owned by the TFEE program. */
    feeVault?: Address<TAccountFeeVault>;
    /** The pool the NFT is sold into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be sold into the pool. */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT being sold. */
    mint: Address<TAccountMint>;
    /** The token account of the seller, where the NFT will be transferred from. */
    sellerTa?: Address<TAccountSellerTa>;
    /** The TA of the pool, where the NFT will be transferred to. */
    poolTa?: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The shared escrow account for pools that pool liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Missing check is performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    escrowProgram?: Address<TAccountEscrowProgram>;
    minPrice: SellNftTradePoolT22InstructionDataArgs['minPrice'];
    creators?: Array<Address>;
    transferHookAccounts: Array<Address>;
};
export declare function getSellNftTradePoolT22InstructionAsync<TAccountOwner extends string, TAccountSeller extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountSellerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string>(input: SellNftTradePoolT22AsyncInput<TAccountOwner, TAccountSeller, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountSellerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>): Promise<SellNftTradePoolT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountSeller, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountSellerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>>;
export type SellNftTradePoolT22Input<TAccountOwner extends string = string, TAccountSeller extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountSellerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string, TAccountEscrowProgram extends string = string> = {
    /** The owner of the pool and the buyer of the NFT, though the NFT will be escrowed by the pool. */
    owner: Address<TAccountOwner>;
    /** The seller is the owner of the NFT who is selling the NFT into the pool. */
    seller: TransactionSigner<TAccountSeller>;
    /** Fee vault account owned by the TFEE program. */
    feeVault: Address<TAccountFeeVault>;
    /** The pool the NFT is sold into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be sold into the pool. */
    whitelist: Address<TAccountWhitelist>;
    /**
     * Optional account which must be passed in if the NFT must be verified against a
     * merkle proof condition in the whitelist.
     */
    mintProof?: Address<TAccountMintProof>;
    /** The mint account of the NFT being sold. */
    mint: Address<TAccountMint>;
    /** The token account of the seller, where the NFT will be transferred from. */
    sellerTa: Address<TAccountSellerTa>;
    /** The TA of the pool, where the NFT will be transferred to. */
    poolTa: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The shared escrow account for pools that pool liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Missing check is performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    escrowProgram?: Address<TAccountEscrowProgram>;
    minPrice: SellNftTradePoolT22InstructionDataArgs['minPrice'];
    creators?: Array<Address>;
    transferHookAccounts: Array<Address>;
};
export declare function getSellNftTradePoolT22Instruction<TAccountOwner extends string, TAccountSeller extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountSellerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string, TAccountEscrowProgram extends string>(input: SellNftTradePoolT22Input<TAccountOwner, TAccountSeller, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountSellerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>): SellNftTradePoolT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountSeller, TAccountFeeVault, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountSellerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram, TAccountEscrowProgram>;
export type ParsedSellNftTradePoolT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the buyer of the NFT, though the NFT will be escrowed by the pool. */
        owner: TAccountMetas[0];
        /** The seller is the owner of the NFT who is selling the NFT into the pool. */
        seller: TAccountMetas[1];
        /** Fee vault account owned by the TFEE program. */
        feeVault: TAccountMetas[2];
        /** The pool the NFT is sold into. */
        pool: TAccountMetas[3];
        /** The whitelist that gatekeeps which NFTs can be sold into the pool. */
        whitelist: TAccountMetas[4];
        /**
         * Optional account which must be passed in if the NFT must be verified against a
         * merkle proof condition in the whitelist.
         */
        mintProof?: TAccountMetas[5] | undefined;
        /** The mint account of the NFT being sold. */
        mint: TAccountMetas[6];
        /** The token account of the seller, where the NFT will be transferred from. */
        sellerTa: TAccountMetas[7];
        /** The TA of the pool, where the NFT will be transferred to. */
        poolTa: TAccountMetas[8];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[9];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[10];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[11];
        /** The Solana system program. */
        systemProgram: TAccountMetas[12];
        /** The shared escrow account for pools that pool liquidity in a shared account. */
        sharedEscrow?: TAccountMetas[13] | undefined;
        /** The account that receives the maker broker fee. */
        makerBroker?: TAccountMetas[14] | undefined;
        /** The account that receives the taker broker fee. */
        takerBroker?: TAccountMetas[15] | undefined;
        /**
         * The optional cosigner account that must be passed in if the pool has a cosigner.
         * Missing check is performed in the handler.
         */
        cosigner?: TAccountMetas[16] | undefined;
        /** The AMM program account, used for self-cpi logging. */
        ammProgram: TAccountMetas[17];
        escrowProgram?: TAccountMetas[18] | undefined;
    };
    data: SellNftTradePoolT22InstructionData;
};
export declare function parseSellNftTradePoolT22Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedSellNftTradePoolT22Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=sellNftTradePoolT22.d.ts.map